src/eCommerce.BackOffice/Controllers/SizesController.cs
using eCommerce.Services.Model;
using eCommerce.Services.Notification;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace eCommerce.BackOffice.Controllers
{
    public class SizesController : Controller
    {
        private DbModelEntities modelEntities = new DbModelEntities();

        public ActionResult Index()
        {
            return View("SizeList", this.SizesToList());
        }

        private List<Size> SizesToList()
        {
            return modelEntities.Sizes.Where(x => x.Deleted == null).OrderByDescending(x => x.SizeId).ToList();
        }

        [HttpGet]
        public ActionResult SizeUpdate(int Id)
        {
            if (Id != -1)
            {
                var size = modelEntities.Sizes.SingleOrDefault(x => x.SizeId== Id && x.Deleted == null);
                return View(size);
            }            
            return View(new Size { SizeId = Id });
        }

        [HttpPost]
        public ActionResult SizeUpdate(FormCollection form)
        {
            Size size= new Size();

            if (form["SizeId"] != string.Empty && Convert.ToInt16(form["SizeId"]) > 0)
            {
                int sizeId = Convert.ToInt16(form["SizeId"]);
                size = modelEntities.Sizes.SingleOrDefault(x => x.SizeId == sizeId && x.Deleted == null);
            }

            TryUpdateModel(size, form);

            if (size.SizeId <= 0)
            {
                modelEntities.Sizes.Add(size);
            }

            modelEntities.SaveChanges();

            NotificationBar.ShowMessage(this, NotificationMessageType.Success, "Los datos fueron guardados correctamente!");
            return RedirectToAction("Index");
        }

        [HttpGet]
        public virtual PartialViewResult SizeDelete(int Id)
        {
            var size = modelEntities.Sizes.SingleOrDefault(x => x.SizeId == Id && x.Deleted == null);
            if (size != null)
            {
                size.Deleted = CurrentDate.Now;
                size.DeletedBy = User.Identity.Name;
                modelEntities.SaveChanges();
            }

            return PartialView("_SizeList", this.SizesToList());
        }

        [HttpPost]
        public JsonResult ModalCreateSize(string Descripcion)
        {
            try
            {
                var size = new Size();

                size.Description = Descripcion;
                modelEntities.Sizes.Add(size);
                modelEntities.SaveChanges();

                return Json(new { tipoMensaje = "success", resultado = "Talle creado exitosamente.", SizeId = size.SizeId, Description = size.Description });
            }
            catch (Exception ex)
            {
                return Json(new { tipoMensaje = "error", resultado = "Se ha generado un error al intentar crear el talle." });
            }
        }
    }
}

src/eCommerce.BackOffice/Views/Sizes/SizeList.cshtml
@model IEnumerable<eCommerce.Services.Model.Size>
@{
    ViewBag.Title = "Medidas";
    Layout = "~/Views/Shared/_ListLayout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Listado de talles</h1>
    <div class="page-header-actions">
        <div class="btn-group btn-group-sm" id="withBtnGroup" aria-label="Page Header Actions" role="group">
            <button type="button" class="btn btn-outline btn-primary" onclick="window.location.href = '/Sizes/SizeUpdate/-1'">
                <i class="icon wb-plus" aria-hidden="true"></i>
                <span class="hidden-xs">NUEVA MEDIDA</span>
            </button>
        </div>
    </div>
</div>

<div class="page-content">

    <div class="panel">
        <div class="panel-body">
            @Html.Partial("_SizeList", Model)
        </div>
    </div>

</div>

@section Scripts {

    <script type="text/javascript">

        $(document).ready(function () {
            //setActionsDialogs();
        })

        function fDelete(Id)
        {
            $.ajax({
                url: "/Sizes/SizeDelete/" + Id,
                type: "GET",
                data: null,
                success: function (data, textStatus, jqXHR)
                {
                    $('.panel-body').html(data);
                    $('.dataTable').DataTable();
                    //setActionsDialogs();
                    swal("Eliminado!", "", "success");
                }
            });
        }

        function fDeleteDialog(sizeId)
        {
            var sizeId = sizeId;
            swal({
                title: "Confirma su acción de Eliminar?",
                text: "",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#F26A54',
                confirmButtonText: 'Sí, deseo elminarlo!',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    fDelete(sizeId);
                }
            });
        }

        function setActionsDialogs()
        {
            $('.remove-row').on("click", function () {
                
            });
        }

    </script>

}

src/eCommerce.BackOffice/Views/Sizes/SizeUpdate.cshtml
@model eCommerce.Services.Model.Size
@{
    ViewBag.Title = "Medidas";
	Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Medidas</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("SizeUpdate", "Sizes", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off"}))
                    {
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Descripción</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Description" value="@Model.Description" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Órden</label>
                            <div class="col-sm-1">
                                <input type="text" class="form-control" name="DisplayOrder" value="@Model.DisplayOrder" />
                            </div>
                        </div>
                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/Sizes'">Cancelar</button>
                            @Html.HiddenFor(model => model.SizeId)
                        </div>
                        <input hidden="hidden" name="flagDelete" id="flagDelete" value="false" />
                    }
                </div>
            </div>
        </div>
    </div>
</div>


@section Scripts {

    <script type="text/javascript">

        (function () {
            $('.form-horizontal').formValidation({
                framework: "bootstrap",
                button: {
                    selector: '#btnSave',
                    disabled: 'disabled'
                },
                icon: null,
                fields: {
                    Description: {
                        validators: {
                            notEmpty: {
                                message: 'El campo Nombre es requerido.'
                            }
                        }
                    }
                }
            });
        })();

        var drEvent = $('#Icon').dropify();
        drEvent.on('dropify.beforeClear', function (event, element) { $("#flagDelete").val(true); });

    </script>
}

src/eCommerce.BackOffice/Views/Sizes/_SizeList.cshtml
@model IEnumerable<eCommerce.Services.Model.Size>

<table class="table table-hover dataTable table-striped width-full" data-plugin="dataTable">
    <thead>
        <tr>
            <th>Descripción</th>
            <th>Órden</th>
            <th class="col-xs-2 text-center">Acciones</th>
        </tr>
    </thead>
    <tbody>
    @foreach (var item in Model)
    {
        <tr>
            <td>@Html.DisplayFor(modelItem => item.Description)</td>
            <td>@Html.DisplayFor(modelItem => item.DisplayOrder)</td>
            <td class="actions text-center">
                <a href="/Sizes/SizeUpdate/@item.SizeId" class="btn btn-sm btn-icon btn-pure btn-default on-default edit-row"
                   data-toggle="tooltip" data-original-title="Editar"><i class="icon wb-edit" aria-hidden="true"></i></a>
                <a href="javascript:void(0);" class="btn btn-sm btn-icon btn-pure btn-default on-default remove-row"
                   data-toggle="tooltip" data-original-title="Eliminar" data-rowid="@item.SizeId" onclick="fDeleteDialog(@item.SizeId)"><i class="icon wb-trash" aria-hidden="true"></i></a>
            </td>
        </tr>
    }
    </tbody>
</table>